<?php
//================================================================================================
//================================================================================================
//==================FOTOPHOLDER 2.51 (French)===============================================================
/*
	Released September 15, 2006 by Jake Olefsky
	Translated into french by Pascasio Montoya 
	Copyright by Jake Olefsky
	http://www.jakeo.com/software/fotopholder/index.php
	
	This software is free to use and modify for non-commercial purposes only.  For commercial use
	of this software please contact me.  Please keep this readme intact at the top of this file,
	and if possible, please keep the link to fotopholder intact at the bottom of the page so other
	people can discover this great script.
	
	If you improve this script, please email me a copy of the improvement so everyone can benefit. 
	
	REQUIREMENTS:
				PHP 4.3+ compiled with GD support for thumbnail creation.
				You'll also need to give this script permission to access the images and permissions 
				to create and fill the cache directory.
	
	SUMMARY:
				This script will look for jpeg or png images and sub-directories of images starting at the 
				same level as this script and descendind as many levels as necessary.  It will display 
				thumbnails and folders in a hierarchical way. Clicking on a folder will take you to the 
				thumbnail view of the folder.  Clicking on a thumbnail will take you to a screen resolution 
				version of that image.
				
	INSTALL:
				Just drop this file inside the top level directory containing images and/or directories
				of images and point your browser to this file.  Thats it.
				
				If you need to fuss with permissions, this script will tell you.  Once you have it working,
				there are a few configurable options you might want to check out lower down in this file.
				
				The following are reserved names that you should not use as folder names: 
					_cache, _screen, _thumbnails, _photoinfo, _icons
					
				To edit the css style, you can check out this file _cache/index_css.css which is created
				the first time you run the script.  The first time you run this script it will ask you to
				set some settings. If you want to change these at a later date, they will be located in the
				_cache/config.php file.
				
	UN-INSTALL: 
				Simply remove this index.php script and delete the cache directory
	
	
	VERSION HISTORY:		
	2.51	Sept 15, 2006
	
			+ Added a fix for a small security flaw (unlikely to cause any harm)
			
	2.5		Sept 11, 2005
	
			+ Addedd page navigation to top of page in addition to bottom of page
			+ Speed up under certain circumstances
			+ Fixed bug when sorting by date that would cause some photos to be invisible
			+ Fixed a security hole
			+ Added ability to view photos as a slideshow
			+ Made the script easily localizable.  If you translate it, please let me know.
			
	2.4		August 20, 2005
	
			+ When you delete a photo on a multipage listing, you stay on that page
			+ Shows the ISO value if set in the EXIF
			+ From the admin panel you can now flatten subfolders into the current folder
			+ Allows you to turn off auto-rotation if it is causing problems for you
			+ Option to password protect viewing of your photos
			+ All your settings are stored in an external file now to make upgrades easier
			+ First time users get a nice walkthrough of the setup process
			+ You can sort folders and photos by modification date now
			
	2.3		July 8, 2005
	
			+ Rotates thumbnail and screen sized images if the camera sets the orientation flag.
			+ Shows the Exif UserComment if it is set
			+ Ability to display large folders with multiple pages
			+ Mac OS X users can turn on SIPS image processing which will make image generation much faster
			+ Improved display speed (especially when you have large subfolders)
			+ Fixed bug with & and " in a folder's name
			+ You can now zip an entire folder up so it can be downloaded all at once
			+ Folder counts and photo counts now include its subdirectories
			+ Misc bug fixes
			
	More version history at... http://www.jakeo.com/software/fotopholder/index.php
	
*/


//================================================================================================	
//================================================================================================
//==================LEAVE EVERYTHING BELOW THIS LINE ALONE========================================
//================================================================================================
if(file_exists("./_cache/config.txt")) rename("./_cache/config.txt","./_cache/config.php");
if(file_exists("./_cache/config.php")) require_once("./_cache/config.php");


//START LANGUAGE
$l_del_fol_err = "Impossible de supprimer le dossier car ce script ne poss&egrave;de pas les permissions requises.  Sous unix, 'chmod -R 777 *' fonctionnera correctement si vous &ecirc;tes dans le m&ecirc;me r&eacute;pertoire que le fichier index.php.";
$l_del_fil_err = "Impossible de supprimer le fichier car ce script ne poss&egrave;de pas les permissions requises.  Sous unix, 'chmod -R 777 *' fonctionnera correctement si vous &ecirc;tes dans le mme r&eacute;pertoire que le fichier index.php.";
$l_rename_err = "Impossible de renommer le fichier car ce script ne poss&egrave;de pas les permissions requises.  Sous unix, 'chmod -R 777 *' fonctionnera correctement si vous &ecirc;tes dans le m&ecirc;me r&eacute;pertoire que le fichier index.php.";
$l_make_err = "Impossible de cr&eacute;er un dossier car le script n&eacute;a pas les permissions requises.  Sous unix, 'chmod -R 777 *' fonctionnera correctement si vous &ecirc;tes dans le m&ecirc;me r&eacute;pertoire que le fichier index.php.";
$l_error = "Erreur";
$l_perm_err = "Probl&egrave;mes de permissions";
$l_not_jpeg = "Ce n&acute;est pas une image JPG";
$l_time = "Date";
$l_shutter = "Vitesse d&acute;obturation";
$l_aperture = "Ouverture";
$l_focal = "Longueur de la focale";
$l_iso = "Valeur ISO";
$l_flash = "Flash";
$l_camera = "Appareil-photo";
$l_comments = "Commentaire";
$l_rating = "Indice";
$l_download = "T&eacute;l&eacute;chargement photo";
$l_download2 = "t&eacute;l&eacute;chargement";
$l_prev = "Pr&eacute;c&eacute;dente";
$l_next = "Suivante";
$l_slide_start = "D&eacute;part du Diaporama";
$l_slide_stop = "Arr&ecirc;t du Diaporama";
$l_pass = "Mot de passe Admin";
$l_tools = "Outils Admin";
$l_login = "Entrer";
$l_logout = "Sortir";
$l_del_photo = "Supprimer cette photo";
$l_regen = "Reg&eacute;n&eacute;rer le Cache";
$l_rename = "Renommer la Photo";
$l_norateing = "Pas d&acute;indice";
$l_save = "Enregistrer";
$l_generated = "Galerie photos g&eacute;n&eacute;r&eacute;e par";
$l_private = "Ceci est un r&eacute;pertoire priv&eacute;. Entrez, ci-dessous, votre mot de passe.";
$l_bad_dir = "R&eacute;pertoire invalide";
$l_bad_dir2 = "R&eacute;pertoire ne pouvant pas &ecirc;tre ouvert";
$l_make_dir = "R&eacute;pertoire en cr&eacute;ation";
$l_photos = "photos";
$l_subfold = "sous-dossiers";
$l_enlarge = "Cliquer pour Agrandir";
$l_more = "suite...";
$l_prev_pg = "Page Prc&eacute;dente";
$l_next_pg = "Page suivante";
$l_confirm_del = "&Ecirc;tes-vous s&ucirc;r de vouloir supprimer cette photo?";
$l_confirm_del2 = "&Ecirc;tes-vous s&ucirc;r de vouloir supprimer ce dossier et tout son contenu?";
$l_fol_empty = "Ce dossier est vide.";
$l_friend = "Fotopholders des Amis";
$l_gen_cache = "G&eacute;n&eacute;ration du cache en entier";
$l_gen_cache2 = "G&eacute;n&eacute;ration du cache en entier";
$l_gen_zip = "G&eacute;n&eacute;ration de l&acute;Archive gzip";
$l_gen_zip2 = "G&eacute;n&eacute;ration de l&acute;Archive gzip";
$l_complete = "Achever";
$l_del_folder = "Supprimer ce dossier";
$l_flatten = "Sous-dossiers horizontaux";
$l_move_to = "D&eacute;placer le dossier vers";
$l_move_top = "NIVEAU SUPERIEUR";
$l_no_move = "NE PAS DEPLACER";
$l_rename_fold = "Renommer le dossier";
$l_add_friend = "Ajout de librairies Fotopholder d&acute;Ami";
$l_url = "URL";
$l_add_friend2 = "Ajout Ami";
$l_download_zip = "T&eacute;l&eacute;chargement d&acute;une Archive de ce Dossier";
//To finish translation you will also need to translate:
//1. Script installation starting on line 732
//2. Definition of Flash starting on line 1123


//START FUNCTIONS	
	function checkGDversion() {
		$capabilities = get_extension_funcs("gd");
		if(!$capabilities) return 0;
		if(in_array ("imagegd2",$capabilities)) return 2;
		return 1;
	}
	function checkExifversion() {
		$capabilities = get_extension_funcs("exif");
		if(!$capabilities) return 0;
		if(in_array ("exif_read_data",$capabilities)) return 1;
		return 0;
	}
	function myURLencode($in) {
		$out = rawurlencode($in);
		$out = str_replace("%2F","/",$out);
		return $out;
	}
	function makeSquare($path, $dim) {
		//This function will create a square image with the photo either cropped or with buffer space added
		//depending on the value of the image_crop variable
		global $image_bkgd, $image_crop;
	
		$gd_Version = checkGDversion();
		if($gd_Version<1) return -1;
			
		if(stristr($path,".png")) $im = @imagecreatefrompng($path);
		else $im = @imagecreatefromjpeg($path);
		
		if(!$im) return -1;
		
		$size = @GetImageSize($path);
		
		if($size[0]==$dim && $size[1]==$dim) return $im;
		
		if($image_crop==1) {
			if($size[0]>$size[1]) {//fat images
				$srcSizeX = $size[1];
				$srcSizeY = $size[1];
				$srcY = 0;
				$srcX = ($size[0]-$size[1])/2;
			} else if($size[0]<$size[1]) { //tall images
				$srcSizeX = $size[0];
				$srcSizeY = $size[0];
				$srcX = 0;
				$srcY = ($size[1]-$size[0])/2;
			} else { //square
				$srcY = 0;
				$srcX = 0;
				$srcSizeX = $size[0];
				$srcSizeY = $size[0];
			}
			$yoffset = 0; //draw in dest at 0,0
			$xoffset = 0;
			$newWidth = $dim;
			$newHeight = $dim;
		} else {
			if($size[0]>$size[1]) { //fat images
				$ratio = $size[0]/$dim;
				$newWidth=$dim;
				$newHeight = round($size[1]/$ratio,0);
			} else if($size[0]<$size[1]) {	//tall images
				$ratio = $size[1]/$dim;
				$newWidth= round($size[0]/$ratio,0);
				$newHeight = $dim;
			} else { //square
				$newWidth = $dim;
				$newHeight = $dim;
			}
			
			$srcSizeX = $size[0];
			$srcSizeY = $size[1];
			$srcY = 0; //draw from src at 0,0
			$srcX = 0;
			$yoffset = ($dim-$newHeight)/2; //draw in dest at offset
			$xoffset = ($dim-$newWidth)/2;
			if($yoffset<0) $yoffset=0;
			if($xoffset<0) $xoffset=0;
		}
		
		//make the new image
		if($gd_Version>=2) $destImage = imagecreatetruecolor( $dim, $dim);  
		else $destImage = ImageCreate( $dim, $dim); 
	
		$color = ImageColorAllocate($destImage,$image_bkgd[0],$image_bkgd[1],$image_bkgd[2]);	
		imagefill($destImage, 0, 0, $color);				//paint it white first
		
		//copy the passed image into the new image at the proper scale
		if($gd_Version>=2) imagecopyresampled( $destImage, $im, $xoffset, $yoffset, $srcX, $srcY, $newWidth, $newHeight, $srcSizeX, $srcSizeY );
		else ImageCopyResized( $destImage, $im, $xoffset, $yoffset, $srcX, $srcY, $newWidth+1, $newHeight+1, $srcSizeX, $srcSizeY );
		
		ImageDestroy($im); //clean up the old image
		
		if(checkExifversion()==1 && $autorotate==1) {
			$details = @exif_read_data($path);
			if(!empty($details['Orientation'])) {
				switch($details['Orientation']) {
					case 1: $rotation = 0; break;
					case 3: $rotation = 180; break;
					case 8: $rotation = 90; break;
					case 6: $rotation = 270; break;
					default: $rotation = 0; break;
				}
				if ($rotation>0) $destImage = @imagerotate($destImage,$rotation,$color);
			}
		}
		
		return $destImage;	//return the new image
	}
	function makeSquareSIPS($path, $save, $dim) {
		global $image_crop;
	
		if($image_crop==1) { //zoom in and crop square
			$size = @GetImageSize($path);
			if($size[0]>$size[1]) $size[0] = $size[1];
			$command = "sips -s format jpeg --cropToHeightWidth ".$size[0]." ".$size[0]." ".escapeshellarg($path)."  --out ".escapeshellarg($save);
			exec($command);
			$command = "sips --resampleHeightWidthMax ".$dim." ".escapeshellarg($save);
			exec($command);
		} else { //pad it
			$command = "sips -s format jpeg --resampleHeightWidthMax ".$dim." --padToHeightWidth ".$dim." ".$dim." ".escapeshellarg($path)."  --out ".escapeshellarg($save);
			exec($command);
		}
		
		if(checkExifversion()==1) {
			$details = @exif_read_data($path);
			if(!empty($details['Orientation'])) {
				switch($details['Orientation']) {
					case 1: $rotation = 0; break;
					case 3: $rotation = 180; break;
					case 6: $rotation = 90; break;
					case 8: $rotation = 270; break;
					default: $rotation = 0; break;
				}
				if($rotation>0)  { //rotate it
					$command = "sips --rotate ".$rotation." ".escapeshellarg($save);
					exec($command);
				}
			}
		}
	}
	function makeScaled($path, $dim) {
		//This function will resize the image keeping the same aspect ratio
		//the max width or height will be $dim
		global $image_bkgd;
	
		$gd_Version = checkGDversion();
		if($gd_Version<1) return -1;
		
		if(stristr($path,".png")) $im = @imagecreatefrompng($path);
		else $im = @imagecreatefromjpeg($path);
		if(!$im) return -1;
		
		$size = @GetImageSize($path);
		
		if(checkExifversion()==1 && $autorotate==1) {
			$details = @exif_read_data($path);
			if(!empty($details['Orientation'])) {
				switch($details['Orientation']) {
					case 1: $rotation = 0; break;
					case 3: $rotation = 180; break;
					case 8: $rotation = 90; break;
					case 6: $rotation = 270; break;
					default: $rotation = 0; break;
				}
				if ($rotation>0) {
					$im = @imagerotate($im,$rotation,0);
					if($rotation==90 || $rotation==270) {
						$temp = $size[0];
						$size[0]=$size[1];
						$size[1]=$temp;
					}
				}
			}
		}
		
		if($size[0]<=$dim && $size[1]<=$dim) return $im;
		
		if($size[0]>$size[1]) { //fat images
			$ratio = $size[0]/$dim;
			$newWidth=$dim;
			$newHeight = round($size[1]/$ratio,0);
		} else if($size[0]<$size[1]) {	//tall images
			$ratio = $size[1]/$dim;
			$newWidth= round($size[0]/$ratio,0);
			$newHeight = $dim;
		} else { //square
			$newWidth = $dim;
			$newHeight = $dim;
		}
		
		//make the new image
		if($gd_Version>=2) $destImage = imagecreatetruecolor( $newWidth, $newHeight);  
		else $destImage = ImageCreate( $newWidth, $newHeight); 
	
		$color = ImageColorAllocate($destImage,$image_bkgd[0],$image_bkgd[1],$image_bkgd[2]);	
		imagefill($destImage, 0, 0, $color);				//paint it white first
		
		//copy the passed image into the new image at the proper scale
		if($gd_Version>=2) imagecopyresampled( $destImage, $im, 0, 0, 0, 0, $newWidth, $newHeight, $size[0], $size[1] );
		else ImageCopyResized( $destImage, $im, 0, 0, 0, 0, $newWidth+1, $newHeight+1, $size[0], $size[1] );
		
		ImageDestroy($im); //clean up the old image
		
		return $destImage;	//return the new image
	}
	
	function makeScaledSIPS($path, $save, $dim) {	
		$command = "sips -s format jpeg --resampleHeightWidthMax ".$dim." ".escapeshellarg($path)."  --out ".escapeshellarg($save);
		exec($command);
		
		if(checkExifversion()==1) {
			$details = @exif_read_data($path);
			if(!empty($details['Orientation'])) {
				switch($details['Orientation']) {
					case 1: $rotation = 0; break;
					case 3: $rotation = 180; break;
					case 6: $rotation = 90; break;
					case 8: $rotation = 270; break;
					default: $rotation = 0; break;
				}
				if($rotation>0)  { //rotate it
					$command = "sips --rotate ".$rotation." ".escapeshellarg($save);
					exec($command);
				}
			}
		}
	}

	//Scans the directory and puts the photo names in an array
	function getPhotoList($path) {
		global $sort_method;
		$photos = array();
		$srcTime=0;
		$extra = 1000;
		
		if(!is_dir($path)) return -1;
		
		if($d = dir($path)) {
	 		while (false !== ($entry = $d->read())) {
	 			$extra++;
	 			if(stristr($entry,".jpg") || stristr($entry,".png")) {
	 				if($sort_method>2) $srcTime = @filemtime($path."/".$entry).$extra;
	 				else $srcTime++;
	 				$photos[$srcTime] = $entry;
	 			}
	 		}
	 		$d->close();
	 	} else {
	 		return -2;
	 	}	 	
	 	if($sort_method==1) asort($photos);
	 	if($sort_method==2) arsort($photos);
	 	if($sort_method==3) ksort($photos);
	 	if($sort_method==4) krsort($photos);
		 
		return $photos;
	}

	//Scans the directory and puts the sub-directory names in an array
	function getDirList($path) {
		global $sort_method;
		$dirs = array();
		$srcTime=0;
		$extra = 1000;
		
		if(!is_dir($path)) return -1;
		
		if($d = dir($path)) {
	 		while (false !== ($entry = $d->read())) {
	 			$extra++;
	 			if(substr($entry,0,1)!="." && !eregi("_cache",$entry) && is_dir($path."/".$entry)) {
	 				if($sort_method>2) $srcTime = filemtime($path."/".$entry).$extra;
	 				else $srcTime++;
	 				$dirs[$srcTime] = $entry;
	 			}
	 		}
	 		$d->close();
	 	} else {
	 		return -2;
	 	}	
	 	if($sort_method==1) asort($dirs);
	 	if($sort_method==2) arsort($dirs);
	 	if($sort_method==3) ksort($dirs);
	 	if($sort_method==4) krsort($dirs);
	 	
	 	return $dirs;
	}
	
	function truncate($name, $len) {
		global $show_extension;
		if($show_extension==0) $name = substr($name,0, strrpos($name,"."));
		
		if(strlen($name)<=$len) return $name;
		return substr($name,0,$len-1)."...";
	}
	
	function rmdirR($dir) {
	  $handle = opendir($dir);
	  while (false!==($e = readdir($handle))) {
		 if($e != "." && $e != "..") { 
		   if(is_dir("$dir/$e")) rmdirR("$dir/$e");  
		   else @unlink("$dir/$e");
		 } 
	  }
	  closedir($handle);
	  $worked = @rmdir($dir);
	  return $worked;
	} 
					
	function sanatizePath($path) {
		$path = str_replace("..","",$path); //remove .. to prevent viewing higher directories
		$path = strip_tags($path); //remove html tags to prevent XSS
		return $path;
	}					
//END FUNCTIONS
	
//START OUTPUT GENERATION
	$version = "2.51";
  	
  	//login
  	if(!empty($HTTP_POST_VARS['admin'])) {
  		if(!empty($password) && $HTTP_POST_VARS['admin']==$password) {
  			setcookie ("admin", md5($HTTP_POST_VARS['admin']), time() + 7200);
  			$_COOKIE['admin']=md5($HTTP_POST_VARS['admin']);
  		} else {
  			setcookie ("admin", '', time() - 7200);
  			$_COOKIE['admin']="";
  		}
  		if(!empty($HTTP_POST_VARS['path'])) $HTTP_GET_VARS['path'] = $HTTP_POST_VARS['path'];
  		if(!empty($HTTP_POST_VARS['file'])) $HTTP_GET_VARS['file'] = $HTTP_POST_VARS['file'];
  		if(!empty($HTTP_POST_VARS['op'])) $HTTP_GET_VARS['op'] = $HTTP_POST_VARS['op'];
  	}
  	//logout
  	if(!empty($HTTP_GET_VARS['admin'])) {
  		setcookie ("admin", '', time() - 7200);
  		$_COOKIE['admin']="";
  	}
  	
  	if(!isset($HTTP_GET_VARS['op'])) $HTTP_GET_VARS['op']=0;
  	
  	if(!empty($HTTP_GET_VARS['path'])) $HTTP_GET_VARS['path'] = sanatizePath($HTTP_GET_VARS['path']);
  	if(!empty($HTTP_GET_VARS['file'])) $HTTP_GET_VARS['file'] = sanatizePath($HTTP_GET_VARS['file']);
  	if(!empty($HTTP_GET_VARS['rename'])) $HTTP_GET_VARS['rename'] = sanatizePath($HTTP_GET_VARS['rename']);
  	
  	if(empty($HTTP_GET_VARS['path'])) $file_path = ".";
	else $file_path = "./".$HTTP_GET_VARS['path'];
		
	if(empty($HTTP_GET_VARS['path'])) $web_path = "";
	else $web_path = $HTTP_GET_VARS['path'];
	
	if(!empty($HTTP_GET_VARS['file'])) $HTTP_GET_VARS['file'] = $HTTP_GET_VARS['file'];
	
	if(empty($web_path)) $slash="";
	else $slash = "/";
		
	//delete file or folder
	if(!empty($admin) && $admin==1 && isset($HTTP_GET_VARS['del']) && $HTTP_GET_VARS['del']==1 && (!empty($HTTP_GET_VARS['path']) || !empty($HTTP_GET_VARS['file'])) && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		if(empty($HTTP_GET_VARS['file'])) {
			rmdirR($file_path);
			rmdirR("./_cache/".$HTTP_GET_VARS['path']);
			if($display_errors==1 && file_exists($file_path)) {
				echo "<table border='0' cellpadding='2' cellspacing='1' bgcolor='#000000'><tr><td bgcolor='#ff9999' colspan='2' class='info'>".$l_del_fol_err."</td></tr></table>";
			} else {
				$array = split("/",$HTTP_GET_VARS['path']);
				array_pop($array);
				$HTTP_GET_VARS['path'] = implode("/",$array);
				
				if(empty($HTTP_GET_VARS['path'])) $file_path = ".";
				else $file_path = "./".$HTTP_GET_VARS['path'];
		
				if(empty($HTTP_GET_VARS['path'])) $web_path = "";
				else $web_path = ($HTTP_GET_VARS['path']);
	
				if(empty($web_path)) $slash="";
				else $slash = "/";
			}
		} else {
			@unlink($file_path."/".$HTTP_GET_VARS['file']);
			@unlink("./_cache/".$HTTP_GET_VARS['path']."/_thumbnails/".$HTTP_GET_VARS['file']);
			@unlink("./_cache/".$HTTP_GET_VARS['path']."/_screen/".$HTTP_GET_VARS['file']);
			if($display_errors==1 && file_exists($file_path."/".$HTTP_GET_VARS['file'])) {
				echo "<table border='0' cellpadding='2' cellspacing='1' bgcolor='#000000'><tr><td bgcolor='#ff9999' colspan='2' class='info'>".$l_del_fil_err."</td></tr></table>";
			}
		}
	}
	
	//regenerate cache for photo
	if(!empty($admin) && $admin==1 && isset($HTTP_GET_VARS['regen']) && $HTTP_GET_VARS['regen']==1 && (!empty($HTTP_GET_VARS['path']) || !empty($HTTP_GET_VARS['file'])) && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		@unlink("./_cache/".$HTTP_GET_VARS['path']."/_thumbnails/".$HTTP_GET_VARS['file']);
		@unlink("./_cache/".$HTTP_GET_VARS['path']."/_screen/".$HTTP_GET_VARS['file']);
		$HTTP_GET_VARS['op'] = 5;
	}
	
	
	//rename folder or rename and add keyword/rating to file
	if(!empty($admin) && $admin==1 && !empty($HTTP_GET_VARS['rename']) && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		
		if($HTTP_GET_VARS['rename']!=$HTTP_GET_VARS['file'] || $HTTP_GET_VARS['path']!=$HTTP_GET_VARS['movepath']) {
			$rename_path = str_replace("index.php","",$HTTP_SERVER_VARS["SCRIPT_FILENAME"]);
			if(empty($HTTP_GET_VARS['path'])) $slash=""; else $slash = "/";
			if(empty($HTTP_GET_VARS['movepath'])) $moveslash=""; else $moveslash = "/";
			
			$worked = @rename($rename_path.$HTTP_GET_VARS['path'].$slash.$HTTP_GET_VARS['file'],$rename_path.$HTTP_GET_VARS['movepath'].$moveslash.$HTTP_GET_VARS['rename']);
			if($worked===FALSE) {
				echo "<table border='0' cellpadding='2' cellspacing='1' bgcolor='#000000'><tr><td bgcolor='#ff9999' colspan='2' class='info'>".$l_rename_err."</td></tr></table>";
			} 
			
			if($HTTP_GET_VARS['renamewhat']==2) { //its a folder
				if($worked) @rename($rename_path."_cache/".$HTTP_GET_VARS['path'].$slash.$HTTP_GET_VARS['file'],$rename_path."_cache/".$HTTP_GET_VARS['movepath'].$moveslash.$HTTP_GET_VARS['rename']);
				if($worked) $HTTP_GET_VARS['path'] = $HTTP_GET_VARS['movepath'].$moveslash.$HTTP_GET_VARS['rename'];
				$file_path = "./".$HTTP_GET_VARS['path'];
				$web_path = $HTTP_GET_VARS['path'];
			} else if($HTTP_GET_VARS['renamewhat']==1) { //its a file
				if($worked) @rename($rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_thumbnails/".$HTTP_GET_VARS['file'],$rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_thumbnails/".$HTTP_GET_VARS['rename']);
				if($worked) @rename($rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_screen/".$HTTP_GET_VARS['file'],$rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_screen/".$HTTP_GET_VARS['rename']);
				if($worked) @rename($rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_photoinfo/".$HTTP_GET_VARS['file'].".txt",$rename_path."_cache/".$HTTP_GET_VARS['path'].$slash."_photoinfo/".$HTTP_GET_VARS['rename'].".txt");
				if($worked) $HTTP_GET_VARS['file'] = $HTTP_GET_VARS['rename'];
				$HTTP_GET_VARS['op'] = 5;
			}
			
		} else {
			$HTTP_GET_VARS['op'] = 5;
		}
		$handle = @fopen("./_cache/".$web_path.$slash."/_photoinfo/".$HTTP_GET_VARS['file'].".txt", "wb");
		@fwrite($handle,$HTTP_GET_VARS['rating']."\n");
		@fwrite($handle,stripslashes($HTTP_GET_VARS['keywords'])."\n");
		@fclose($handle);
	}
	
	//add a friend
	if(!empty($admin) && $admin==1 && !empty($HTTP_GET_VARS['friend']) && $HTTP_GET_VARS['friend']!="http://" && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		$handle = @fopen($HTTP_GET_VARS['friend'], "rb");
		$temp = @fgets($handle,1024);
		while(!stristr($temp,"<title>")) {
			$temp = @fgets($handle,1024);
		}
		$title = trim(strip_tags($temp));
		fclose($handle);
		
		$handle = @fopen("./_cache/friend.txt", "a");
		@fwrite($handle,$HTTP_GET_VARS['friend']."\n");
		@fwrite($handle,$title."\n");
		fclose($handle);
	}
	
	//flatten subdirectories
	//LIMITATIONS: if the file/folder exist, it prefixes some random letters.  Doesnt work on root. 
	if(!empty($_GET['flatten'])) {
		$subdirs = getDirList($_GET['path']);
		foreach($subdirs as $s) {
			$flat_path = $_GET['path']."/".$s;
			if(is_dir($flat_path)) {
				if($d = dir($flat_path)) {
					while (false !== ($entry = $d->read())) {
						if(substr($entry,0,1)!="." && !eregi("_cache",$entry)) {
							$prefx='';
							if(file_exists($_GET['path']."/".$entry)) {
								$prefx = substr(md5(uniqid("_")),0,3)."_";
							}
							if(!file_exists($_GET['path']."/".$prefx.$entry)) {
								$worked = @rename($flat_path."/".$entry,$_GET['path']."/".$prefx.$entry);
								if($worked && is_dir($_GET['path']."/".$entry)) { //moved dir
									@rename("_cache/".$flat_path."/".$entry,"_cache/".$_GET['path']."/".$prefx.$entry);
								} else if($worked) { //moved photo
									@rename("_cache/".$flat_path."/_thumbnails/".$entry,"_cache/".$_GET['path']."/_thumbnails/".$prefx.$entry);
									@rename("_cache/".$flat_path."/_screen/".$entry,"_cache/".$_GET['path']."/_screen/".$prefx.$entry);
									@rename("_cache/".$flat_path."/_photoinfo/".$entry.".txt","_cache/".$_GET['path']."/_photoinfo/".$prefx.$entry.".txt");
								} else {
									//error
								}
							}
						}
					}
					$d->close();
				}
			}
		}
	}
		
	if(isset($HTTP_GET_VARS['op']) && ($HTTP_GET_VARS['op']==1 || $HTTP_GET_VARS['op']==2)) { //image generation
		if($HTTP_GET_VARS['op']==1) {
			$subdir = "_thumbnails";
			$image_size = $thumb_size;
		} else if($HTTP_GET_VARS['op']==2) {
			$subdir = "_screen";
			$image_size = $screen_size;
		}
		
		if(!isset($HTTP_GET_VARS['path']) || $HTTP_GET_VARS['path']=="") {
			$file_path = $HTTP_GET_VARS['file'];
			$save_path = "./_cache/".$subdir."/".$HTTP_GET_VARS['file'];
		} else {
			$file_path = $HTTP_GET_VARS['path']."/".$HTTP_GET_VARS['file'];
			$save_path = "./_cache/".$HTTP_GET_VARS['path']."/".$subdir."/".$HTTP_GET_VARS['file'];
		}
		
		$image = 0;
		if(!file_exists($save_path)) { //thumbnail does not exist.  Lets make it!
		
			if($use_sips) {
				if($HTTP_GET_VARS['op']==1) { //thumbnail
					makeSquareSIPS($file_path,$save_path,$image_size);
				}
				if($HTTP_GET_VARS['op']==2) { //screen
					makeScaledSIPS($file_path,$save_path,$image_size);
				}
			} else {
				if($HTTP_GET_VARS['op']==1) $image = makeSquare($file_path, $image_size);
				if($HTTP_GET_VARS['op']==2) $image = makeScaled($file_path, $image_size);
				
				if($image!=-1) {
					$success = @Imagejpeg($image,$save_path,$jpeg_compression);
				}
			}
		}
	
		Header("Content-type: image/jpeg");
		$im = @imagecreatefromjpeg($save_path);
		if($im) {
			Imagejpeg($im,'',$jpeg_compression);
		} else if($image) {
			Imagejpeg($image,'',$jpeg_compression);
		} else {
			$im = ImageCreate($image_size,$image_size); 
			$white = ImageColorAllocate($im,255,255,255);	
			$black = ImageColorAllocate($im,0,0,0);	
			imagefill($im, 0, 0, $white);
			imagestring($im,1,2,2,$l_error,$black);
			if(!isset($success)) imagestring($im,1,2,10,$l_not_jpeg,$black);
			else imagestring($im,1,2,10,$l_perm_err,$black);
			Imagejpeg($im,'',80);
		}
		if($im) ImageDestroy($im); 
		if($image) ImageDestroy($image);
		
	} else if(isset($HTTP_GET_VARS['op']) && $HTTP_GET_VARS['op']==4) { //folder icon generation
		Header("Content-type: image/jpeg");
		$im = ImageCreate(15,14); 
		$white = ImageColorAllocate($im,255,255,255);	
		$tan = ImageColorAllocate($im,192,128,64);	
		$black = ImageColorAllocate($im,0,0,0);	
		imagefill($im, 0, 0, $white);
		
		imageline($im,2,4,4,2,$black); //left tab edge
		imageline($im,7,2,9,4,$black); //right tab edge
		imageline($im,4,2,7,2,$black); //tab top
		imageline($im,2,4,2,13,$black); //left side
		imageline($im,2,13,14,13,$black); //bottom
		imageline($im,14,13,14,5,$black); //right
		imageline($im,13,4,9,4,$black); //top
		
		imagefill($im, 10, 10, $tan);
		
		Imagejpeg($im,'',80);
		ImageDestroy($im); 
	} else { //directory output

	
	//Please leave the following invisible html comments in place.
?>
<!-- This photo gallery was generated with Fotopholder <?php echo $version?> -->
<!-- http://www.jakeo.com/software/fotopholder/index.php -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head>
<?
	$hasGD = checkGDversion();

	if(!file_exists("./_cache") || !file_exists("./_cache/config.php")) { //cache doesnt exist.  First time through.
		if(!file_exists("./_cache")) $success = @mkdir("./_cache",0777);
		
		if(is_writable (".") && is_writable ("./_cache") && $hasGD) {
			
			if(!empty($_POST['settings'])) {
				$handle = fopen("./_cache/config.php", "wb");
				$data = "<?php\n";
				$data .= "\$album_name = \"".$_POST['album_name']."\";	//Le nom de votre album\n";
				$data .= "\$display_errors = ".$_POST['display_errors'].";	//mettre  0 une fois que le script est correctement install et il vous donne satisfaction\n";
				$data .= "\$no_screen = ".$_POST['no_screen'].";	//mettre  1 et l'image originelle sera utilise pour l'affichage lorsque vous cliquerez la miniature  la place de l'image gnre en taille moyenne\n";
				$data .= "\$use_sips = ".$_POST['use_sips'].";	//Pour les Utilisateur de Mac os X seulement. Essayez en mettant  1 pour voir si vous activer la cration des miniuatures\n";
				$data .= "\$screen_size = ".$_POST['screen_size'].";	//largeur ou hauteur max de l'image redimensionne  l'cran\n";
				$data .= "\$thumb_size = ".$_POST['thumb_size'].";	// largeur et hauteur de la miniature\n";
				$data .= "\$tiny_size = ".$_POST['tiny_size'].";	//largeur et hauteur des petites miniatures  utiliser dans les dossiers de classement\n";
				$data .= "\$num_tinys = ".$_POST['num_tinys'].";	//nombre de petites miniatures  afficher dans le dossier de classement\n";
				$data .= "\$thumb_cols = ".$_POST['thumb_cols'].";	//nombre de miniatures normales  visualiser par colonne\n";
				$data .= "\$thumbs_page = ".$_POST['thumbs_page'].";	//Nombre de miniatures  afficher par page pour les dossiers volumineux\n";
				$data .= "\$autorotate = ".$_POST['autorotate'].";	//Mettre  1 pour permettre la rotation d'une image si l'appareil photo active l'orientation EXIF\n";
				$data .= "\$sort_method = ".$_POST['sort_method'].";	//comment trier les rpertoires et les noms de fichiers. Valeurs Possibles : 0=pas de tri, 1=ordre alpha ascendant, 2=ordre alpha descendant 3=date asc 4-date desc\n";
				$data .= "\$show_filename = ".$_POST['show_filename']."; //1 affiche le nom de fichier des photos dans la visualisation de la liste. 0 cache le nom de fichier \n";
				$data .= "\$display_rating = ".$_POST['display_rating']."; //1 Affiche les classements par toiles.  0 ne pas les afficher\n";
				$data .= "\$show_extension = ".$_POST['show_extension']."; //1 affiche les extentions des fichiers. 0 ne pas les afficher \n";
				$data .= "\$max_file_length = ".$_POST['max_file_length']."; //longueur  laquelle les noms de fichiers seront tronqus pour remplir les besoins de l'affichage\n";
				$data .= "\$show_extra_info = ".$_POST['show_extra_info']."; //1=affiche des informations supplmentaires sur une image si elles sont disponibles (ouverture, vitesse d'obsturation, etc)\n";
				$data .= "\$jpeg_compression = ".$_POST['jpeg_compression']."; //taux de compression des images miniatures. 100=superbe, 0=laide\n";
				$data .= "\$image_crop = ".$_POST['image_crop']."; //1=la miniature est agrandie et rogne dans un carr 0=la miniature est rembourre dans un carr\n";
				$data .= "\$admin = ".$_POST['admin']."; //mettre  1 pour activer les outils d'admin permettant de supprimer et de rnommer les dossiers et les fichiers\n";
				$data .= "\$admin_only = ".$_POST['admin_only']."; //mettre  1 pour cacher un album priv avec des photos jusqu' ce que le mot de passe soit entr\n";
				$data .= "\$password = '".$_POST['password']."'; //s'est le mot de passe admin ncessaire pour effectuer les changements\n";
				$data .= "\$delete_tiny_files = ".$_POST['delete_tiny_files']."; //mettre  1 pour supprimer automatiquement les images sans aucune attache (probablement d'anciennes miniatures)\n";
				$data .= "\$tiny_file_max_kbytes = ".$_POST['tiny_file_max_kbytes']."; //s'est la taille max pour les images sans aucune attache qui seront supprimes\n";
				$data .= "\$delete_empty_folders = ".$_POST['delete_empty_folders']."; //mettre  1 pour supprimer automatiquement les dossiers vides\n";
				$data .= "\$gallery_link = ".$_POST['gallery_link']."; //mettre  1 pour afficher un lien  votre galerie de photos sur la page d'accueil de fotopholder\n";
				$data .= "\$gallery_link_url = \"".$_POST['gallery_link_url']."\"; //l'url de votre galerie de photos si vous souhaitez la partager dans le website fotopholder.\n";
				
				if(!empty($_POST['image_bkgd']) && $_POST['image_bkgd']==1) $data .= "\$image_bkgd = array( 0,0,0 ); //(rouge, vert, bleu) couleur de l'espace de remplissage dans les miniatures rembourres\n";
				else if(!empty($_POST['image_bkgd']) && $_POST['image_bkgd']==2) $data .= "\$image_bkgd = array( 128,128,128 ); //(rouge, vert, bleu) couleur de l'espace de remplissage dans les miniatures rembourres\n";
				else $data .= "\$image_bkgd = array( 255,255,255 ); //(rouge, vert, bleu) couleur de l'espace de remplissage dans les miniatures rembourres\n";

				$data .= "?>";
				fwrite($handle,$data."\n");
				fclose($handle);
			
				if(file_exists("./_cache/config.php")) {
					?>
					<title>FotoPholder <?php echo $version?></title>
					</head><body>
					<h1>F&eacute;licitations</h1>
					<p>Votre galerie a &eacute;t&eacute; correctement install&eacute;e.</p>
					<br />
					<b><a href="index.php">Affichage de la galerie</a></b>
					</body></html>
					<?php
					exit();
				}
			} else {
				?>
				<title>Votre titre - Galerie photos></title>
				</head><body bgcolor="#eeeeff">
				<h1>Bienvenue dans FotoPholder <?php echo $version?></h1>
				
				<p>Tout c&acute;est bien d&eacute;roul&eacute; jusqu&acute;ici.  V&eacute;rifiez et modifiez si n&eacute;cessaire ces paramtres par d&eacute;fauts pour votre nouvelle galerie.</p>
	
				<form action="index.php" method="post">
				<input type="hidden" name="settings" value="1" />
				
				<table border="1" cellpadding="5" cellspacing="0">
				<tr><td width="300"><b>Nom de l&acute;Album</b></td><td>
				<input type="text" name="album_name" size="30" value="My Album" />
				
				</td></tr><tr><td><b>Format de l&acute;Image &agrave; l&acute;&eacute;cran</b><br />Utiliser l&acute;image d&acute;origine ou effectuer une r&eacute;duction pour l&acute;afficher &agrave; l&acute;&eacute;cran.</td><td>
				<input type="radio" name="no_screen" value="1" />Utiliser l&acute;Original
				<input type="radio" name="no_screen" value="0" checked="checked" />R&eacute;duite aux dimensions de ci-dessous
				<br />
				Largeur ou hauteur Max: <input type="text" name="screen_size" size="10" value="600" />
				
				</td></tr><tr><td><b>Taille des miniatures</b><br />Largeur et hauteur de la miniature.</td><td>
				<input type="text" name="thumb_size" size="10" value="100" />
				
				</td></tr><tr><td><b>Taille des petites miniatures</b><br />Largeur et hauteur de la petite miniature utilis&eacute;es dans le dossier listes.</td><td>
				<input type="text" name="tiny_size" size="10" value="50" />
			
				</td></tr><tr><td><b>Nombre de Petites Miniatures</b><br />Nombre de petites miniatures &agrave; afficher dans le dossier listes.</td><td>
				<input type="text" name="num_tinys" size="10" value="10" />
				
				</td></tr><tr><td><b>Colonnes</b><br />Nombre de colonnes de miniatures.</td><td>
				<input type="text" name="thumb_cols" size="10" value="7" />
				
				</td></tr><tr><td><b>Miniatures par Page</b><br />Nombre de miniatures par page. Doit &ecirc;tre un multiple du nombre de colonnes pour des pages agrables.</td><td>
				<input type="text" name="thumbs_page" size="10" value="49" />
				
				</td></tr><tr><td><b>Afficher le nom des fichiers</b><br />Afficher le nom de fichier dans le dossier des listes.</td><td>
				<input type="radio" name="show_filename" value="1" checked="checked" />Oui
				<input type="radio" name="show_filename" value="0" />Non
				
				</td></tr><tr><td><b>Longueur Maximun du nom de fichier</b><br />Les noms de fichier qui exc&eacute;dent cette valeur seront tronqu&eacute;s.</td><td>
				<input type="text" name="max_file_length" size="10" value="20" />
				
				</td></tr><tr><td><b>Afficher les classements en toiles</b><br />Affiche le classement en &eacute;toiles que vous donnez &agrave; chaque photo.</td><td>
				<input type="radio" name="display_rating" value="1" checked="checked" />Oui
				<input type="radio" name="display_rating" value="0" />Non
				
				</td></tr><tr><td><b>Afficher les extentions</b><br />Afficher l&acute;extention de la photo.</td><td>
				<input type="radio" name="show_extension" value="1" />Oui
				<input type="radio" name="show_extension" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>Afficher les infos Extra (EXIF) des Photos</b><br />Afficher les infos EXIF de la photo si elle sont disponibles (ouverture, vitesse de l&acute;obturateur, etc)</td><td>
				<input type="radio" name="show_extra_info" value="1" checked="checked" />Oui
				<input type="radio" name="show_extra_info" value="0" />Non
				
				</td></tr><tr><td colspan="2" bgcolor="#ccccff">Param&egrave;tres Techiques

				</td></tr><tr><td><b>Taux de Compression JPEG</b><br />Donnez le chiffre de compression que vous d&eacute;sirez appliquer comme pourcentage.  100= photo de bonne qualit&eacute; et 0=photo appauvrit.</td><td>
				<input type="text" name="jpeg_compression" size="4" value="80" />%
				
				</td></tr><tr><td><b>Utilisation de SIPS</b><br />Pour seulement les utilisateurs de Mac OS X. Essayez ce param&egrave;tre pour voir si la vitesse de cr&eacute;ation des miniatures augmente.</td><td>
				<input type="radio" name="use_sips" value="1" />Oui
				<input type="radio" name="use_sips" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>Autorotation des Images</b><br />Tentative pour la rotation  de l&acute;image si l&acute;appareil photo a activ&eacute; l&acute;indicateur.</td><td>
				<input type="radio" name="autorotate" value="1" />Oui
				<input type="radio" name="autorotate" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>M&eacute;thode de Tri</b><br />Comment trier les r&eacute;pertoires et les dossiers.</td><td>
				<input type="radio" name="sort_method" value="0" />Non tri&eacute;s<br />
				<input type="radio" name="sort_method" value="1" checked="checked" />Alphab&eacute;tique A-Z<br />
				<input type="radio" name="sort_method" value="2" />Alphab&eacute;tique inverse Z-A<br />
				<input type="radio" name="sort_method" value="3" />Date de Modification du fichier (le plus ancien en premier)<br />
				<input type="radio" name="sort_method" value="4" />Date de modification du fichier (le plus rcent en premier)
				
				</td></tr><tr><td><b>Rogner les Miniatures</b><br />Comment faire des miniatures carr&eacute;es avec des photos rectangulaires.</td><td>
				<input type="radio" name="image_crop" value="1" checked="checked" />Agrandir et rogner les images pour fair un carr.<br />
				<input type="radio" name="image_crop" value="0" />Remplir les Images pour faire un carr en utilisantl&eacute;image de couleur d'arri&egrave;re plan
				
				</td></tr><tr><td><b>Couleur de l&acute;Image d&acute;Arri&egrave;re plan</b><br />Utiliser seulement si le remplissage des miniatures est activ&eacute; ci-dessus</td><td>
				<input type="radio" name="image_bkgd" value="0" checked="checked" />Blanc
				<input type="radio" name="image_bkgd" value="1" />Noir
				<input type="radio" name="image_bkgd" value="2" />Gris
				
				</td></tr><tr><td colspan="2" bgcolor="#ccccff">Param&egrave;tres de gestion
				
				</td></tr><tr><td><b>Activer les Utilitaires Admin</b><br />Permettre &agrave; l&acute;Admin de s&acute;identifier et d&acute;utiliser les utilitaires pour g&eacute;rer sa galerie photos</td><td>
				<input type="radio" name="admin" value="1" />Oui
				<input type="radio" name="admin" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>Mot de passe Admin</b><br />Ceci est le mot de passe utilis&eacute; pour activer les utilitaires admin</td><td>
				<input type="text" name="password" size="10" value="secret" />
				
				</td></tr><tr><td><b>Rendre les Photos Priv&eacute;es</b><br />Ceci rendra votre album totalement prot&eacute;g&eacute; par mot de passe.</td><td>
				<input type="radio" name="admin_only" value="1" />OUI
				<input type="radio" name="admin_only" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>Supprimer les fichiers minuscules</b><br />Tout fichier minuscule qui n&acute;ex&egrave;de pas cette taille minimum sera supprim&eacute; . Utilisez ceci pour nettoyer les anciennes images miniatures cr&eacute;&eacute;es par d&acute;autres application de cr&eacute;ation de galerie photos.</td><td>
				<input type="radio" name="delete_tiny_files" value="1" />Oui
				<input type="radio" name="delete_tiny_files" value="0" checked="checked" />Non
				<br />Taille Minimum des fichiers: <input type="text" name="tiny_file_max_kbytes" size="5" value="10" />Kilo octets
				
				</td></tr><tr><td><b>Supprimer les Dossiers Vides</b><br />Tout dossier vide sera supprim&eacute;.</td><td>
				<input type="radio" name="delete_empty_folders" value="1" />Oui
				<input type="radio" name="delete_empty_folders" value="0" checked="checked" />Non
				
				</td></tr><tr><td><b>Afficher les Erreurs</b><br />Si le script rencontre des erreurs souhaitez vous les affich&eacute;es?
				</td><td>
				<input type="radio" name="display_errors" value="1" checked="checked" />Oui
				<input type="radio" name="display_errors" value="0" />Non
				
				</td></tr><tr><td><b>Partager sa galerie</b><br />Si vous s&eacute;lectionnez 'Oui' un lien &agrave; votre galerie de photos s&acute;affichera sur la page d&acute;accueil pour le script fotopholder.</td><td>
				<input type="radio" name="gallery_link" value="1" />Oui
				<input type="radio" name="gallery_link" value="0" checked="checked" />Non<br />
				Url de votre galerie: <input type="text" name="gallery_link_url" size="30" value="http://" />
				</td></tr>
				
				</table>
			
				<p>Ces param&egrave;tres vont &ecirc;tre enregistr&eacute;s dans le fichier suivant: <b><?php echo $_SERVER["DOCUMENT_ROOT"].str_replace("index.php","",$_SERVER["SCRIPT_NAME"])?>_cache/config.php</b> . Par la suite vous pourrez modifier les param&egrave;tres en affichant le fichier dans un diteur ad&eacute;quat.</p>
				<input type="submit" value="Save Settings" />
				</form>
				
				</body></html>
				<?php
				exit();
			}
		} else {
			$success=FALSE;
		}

		if(empty($success) && $hasGD) {
		?>
		<title>FotoPholder <?php echo $version?></title>
		</head><body>
		<h1>Bienvenue dans FotoPholder <?php echo $version?></h1>
		<p>Les permissions d&acute;acc&egrave;s &agrave; votre fichier sont incorrectes. Ce script a besoin d&acute;avoir un acc&egrave;s en lecture et &eacute;criture &agrave; votre r&eacute;pertoire de photos.</p>
		<br /><b>Sous Unix</b><br />
		<p>Vous avez besoin d&acute;utiliser l&acute;application TELNET pour vous identifier au serveur comme root ou toute autre application vous donnant acc&egrave;s aux permissions de fichier (CHMOD). La commande suivante vous permet de donner l&acute;acc&egrave;s en lecture et &eacute;criture &agrave; ce script: <b>chmod -R 777 <?php echo $_SERVER["DOCUMENT_ROOT"].str_replace("/index.php","",$_SERVER["SCRIPT_NAME"])?></b></p>
		<br /><b>Sous Mac OS X</b><br />
		<p>Trouvez le <b><?php echo $_SERVER["DOCUMENT_ROOT"].str_replace("index.php","",$_SERVER["SCRIPT_NAME"])?></b> r&eacute;pertoire.  Cliquez Control sur le r&eacute;pertoire et s&eacute;lectionnez "Get Info".  En bas de la fen&ecirc;tre des informations, sous 'Details', assurez vous qu&acute;il indique 'Read &amp; Write' pour l&acute;ensemble des trois sections. Si c&acute;est le cas cliquez sur 'Apply to enclosed items'.</p>
		<br /><b>Sous Windows</b><br />
		<p>Trouvez le <b><?php echo $_SERVER["DOCUMENT_ROOT"].str_replace("index.php","",$_SERVER["SCRIPT_NAME"])?></b> r&eacute;pertoire et donnez &agrave; ce script l&acute;acc&egrave;s en &eacute;criture &agrave; celui-ci.</p>
		</body></html>
		<?php
		exit();
		} else {
		?>
		<title>FotoPholder <?php echo $version?></title>
		</head><body>
		<h1>Bienvenue dans FotoPholder <?php echo $version?></h1>
		<p>La configuration de votre syst&egrave;me ne permet pas le fonctionnement de FotoPholder.  Il est imp&eacute;ratif de poss&eacute;der PHP compil&eacute; avec la librairie GD.  Vous trouverez plus d&acute;informations sur et autour de GD et PHP <a href="http://us2.php.net/manual/en/ref.image.php">Ici</a>.</p>
		</body></html>
		<?php
		exit();
		}
	}
?>


<title><?php echo $album_name?> <?php if(!empty($web_path)) echo ":"; ?> <?php echo str_replace("/"," : ",$web_path)?></title>
<?php
	if(!file_exists("./_cache/index_css.css")) {
		$handle = @fopen("./_cache/index_css.css", "wb");
		$data = "html, body, h1, h2, h3, h4, h5, h6, div, span, iframe { margin:0px; padding:0px; }
img  { margin:0px; padding:0px; border: 0px; }
form { display:inline; margin:0px; padding:0px; }
hr { height: 1px; margin: 10px 0px 10px 0px; }

body {
	background-color:#eeeeff;
	font-family:arial, sans-serif;
	font-size:90%;
}

.dir_table { border: 1px solid #000000; background-color:#ffffff; width:98%; margin: 0px 0px 0px 5px;}
.dir_table_info { width:150px; text-align: top; padding: 3px 0px 3px 0px;}
.dir_table_thumbs { text-align: middle; font-size: 1em; padding: 3px 0px 3px 0px;}

.photo_table { background-color:#ffffff; border: 1px solid #000000; width:98%; margin: 0px 0px 0px 5px;}
.photo_table_cell { border-right: 1px solid #000000; padding: 0px 0px 5px 0px;}
.photo_table_cell_l { border-right: 1px solid #000000;padding: 0px 0px 5px 0px; }
.photo_table_cell_r { padding: 0px 0px 5px 0px; }
.photo_table_cell_e { padding: 0px 0px 5px 0px; }
.photo_table_cell_n { padding: 5px 5px 5px 5px; }
.photo_table_spacer { background-color:#cccccc; height:10px; border-bottom: 1px solid #000000; border-top: 1px solid #000000;}

.details_table { background-color:#ffffff; border: 1px solid #000000; width:98%; margin: 0px 0px 0px 5px;}
.details_table_cell_l { border-right: 1px solid #000000; padding: 5px 5px 5px 5px; width:200px; }
.details_table_cell_r { padding: 0px; }

.crumbs { font-size: 1.1em; font-weight:bold; margin: 0px 0px 10px 5px;}

.admin_table { border: 1px solid #000000; background-color:#ffffff; width:98%; margin: 0px 0px 0px 5px;}
.admin_heading { border-bottom: 2px solid #aa7777; background-color:#cc9999; padding: 2px 0px 3px 5px; font-size: 1.1em; font-weight:bold;}
.admin_cell { background-color:#ffcccc; padding: 10px 0px 10px 5px;}

.friend_table { border: 1px solid #000000; background-color:#ffffff; width:98%; margin: 0px 0px 0px 5px;}
.friend_heading { border-bottom: 2px solid #77aa77; background-color:#99cc99; padding: 2px 0px 3px 5px; font-size: 1.1em; font-weight:bold;}
.friend_cell { background-color:#ccffcc; padding: 10px 0px 10px 5px;}

.form_btn { border: 1px solid #000000; background-color:#ccccff; font-size: 0.8em; }
.form_btn:hover { border: 1px solid #000000; background-color:#9999ff; font-size: 0.8em; }
.form_text { border: 1px solid #000000; background-color:#ffffff; font-size: 0.8em; padding: 2px;}
.form_text:hover { border: 1px solid #000066; background-color:#ffffcc; font-size: 0.8em; padding: 2px;}

.error { border: 1px solid #000000; background-color:#ffcccc; width:98%; margin: 0px 0px 0px 5px;}

a { color: #000099; text-decoration: none;}
a:hover { color: #660099; text-decoration: underline;}
 
b { font-size: 1.1em; font-weight:bold;}
.folder { font-size: 1em;}
.info { font-size: 0.8em; }
.info_bold { font-size: 0.8em; font-weight:bold;}
.tag { color: #666666; font-size: 0.9em; font-weight:normal;  margin: 0px 0px 0px 5px;}
a.tag_lnk { color: #666666; text-decoration: underline;}";
		@fwrite($handle,$data."\n");
		@fclose($handle);
		echo "<style type='text/css'>".$data."</style>";
	} else { 
	?>
<link rel="stylesheet" type="text/css" href="_cache/index_css.css" media="screen" />
<?php } ?>

</head>
<body>

<div class="crumbs">
<?php 
	// START CRUMBS
		$crumbs = split("/", $web_path);
		if($crumbs[0]=="" && $HTTP_GET_VARS['op']!=5) echo $album_name;
		else echo "<a href='index.php'>".$album_name."</a>";
	
		$total = "";
		$num=0;
		foreach ($crumbs as $crumb) {
			if($crumb!="" && $crumb!=".") {
				$num++;
				if($total!="") $total.="/";
				$total.=$crumb;
				if($num!=sizeof($crumbs)) echo " : <a href='index.php?path=".rawurlencode($total)."'>".$crumb."</a>";
				else if($HTTP_GET_VARS['op']==5) echo " : <a href='index.php?path=".rawurlencode($total)."'>".$crumb."</a>";
				else echo " : ".$crumb;
			}
		}
		if($HTTP_GET_VARS['op']==5) echo " : ".$HTTP_GET_VARS['file'];
	// END CRUMBS
?>
</div>

<?php
//IMAGE DETAILS
if($HTTP_GET_VARS['op']==5) {
	if($no_screen==1) { 
		if(empty($web_path)) $screen_path = "./".$HTTP_GET_VARS['file'];
		else $screen_path=$web_path."/".$HTTP_GET_VARS['file'];
		$size = @getimagesize($screen_path);
		$screen_size = $size[0];
		$dim = "width='".$size[0]."' height='".$size[1]."'";
	} else {
		$screen_path = "index.php?op=2&amp;path=".rawurlencode($web_path)."&amp;file=".rawurlencode($HTTP_GET_VARS['file']);
		
		if(empty($web_path)) $size=@getimagesize("./_cache/_screen/".$HTTP_GET_VARS['file']);
		else $size=@getimagesize("./_cache/".$web_path."/_screen/".$HTTP_GET_VARS['file']);
		
		if(!empty($size)) $dim = "width='".$size[0]."' height='".$size[1]."'";
		else $dim="";
	}
	
	//get previous and next photos
	$photos = getPhotoList("./".$web_path);
	if(is_array($photos)) {
		$last = '';
		foreach ($photos as $photo) {
			$prev = $last;
			$last = $photo;
			if($photo==$HTTP_GET_VARS['file']) break;
		}
		$next = current($photos);
	}
	if(file_exists("./_cache/_icons/prev.gif")) {
		$prev_icon = "<img src='./_cache/_icons/prev.gif' width='9' height='10' border='0' alt='&lt;' />";
	} else {
		$prev_icon = "&lt;--";
	}
	if(file_exists("./_cache/_icons/next.gif")) {
		$next_icon = "<img src='./_cache/_icons/next.gif' width='9' height='10' border='0' alt='&gt;' />";
	} else {
		$next_icon = "--&gt;";
	}
		
	?>

	<table border="0" cellpadding="0" cellspacing="0" class="details_table">
	<tr><td class="details_table_cell_l" valign="top">
	<?php 
	if(checkExifversion()==1) {
		$details = @exif_read_data($file_path."/".$HTTP_GET_VARS['file']);
		if(!empty($details['UserComment'])) $details['UserComment'] = trim($details['UserComment']);
	}
	echo "<b>".truncate($HTTP_GET_VARS['file'],strlen($HTTP_GET_VARS['file']))."<br /><br /></b>";
		
	if(!empty($details) && $show_extra_info==1) {
		?>
		<?php if(!empty($details['DateTime'])) { ?><span class="info_bold"><?php echo $l_time;?>: </span><span class="info"><?php echo $details['DateTime']?> <br /></span><?php } ?>
		
		<?php if(!empty($details['ExposureTime'])) { 
			$fraction = split("/",$details['ExposureTime']);
			if($fraction[0]/10 == 1) $exposureTime="1/".round($fraction[1]/10, 0)." sec"; //top is 10
			else $exposureTime=$fraction[0]."/".$fraction[1]." sec"; //top is some other number
			?>
		<span class="info_bold"><?php echo $l_shutter;?>: </span><span class="info"><?php echo $exposureTime?><br /></span><?php } ?>
		
		<?php if(!empty($details['FNumber'])) { 
			$fraction = split("/",$details['FNumber']);
			if($fraction[1]!=0) $fnumber="f ".($fraction[0]/$fraction[1]); 
			else $fnumber="f ".$details['FNumber']; 
			?>
		<span class="info_bold"><?php echo $l_aperture;?>: </span><span class="info"><?php echo $fnumber?><br /></span><?php } ?>
		
		<?php if(!empty($details['FocalLength'])) { 
			$fraction = split("/",$details['FocalLength']);
			if($fraction[1]!=0) $fnumber=($fraction[0]/$fraction[1])."mm"; 
			else $fnumber=$details['FocalLength']."mm"; 
			?>
		<span class="info_bold"><?php echo $l_focal;?>: </span><span class="info"><?php echo $fnumber?><br /></span><?php } ?>
		<?php if(!empty($details['ISOSpeedRatings'])) { ?>
		<span class="info_bold"><?php echo $l_iso;?>: </span><span class="info"><?php echo $details['ISOSpeedRatings']?><br /></span><?php } ?>
		
		<?php if(!empty($details['Flash'])) { 
			switch($details['Flash']) {
			case 0: $flash = "Aucun"; break;
			case 1: $flash = "Flash"; break;
			case 5: $flash = "Flash, lumi&egrave;re stroboscopique de retour non d&eacute;tect&eacute;e"; break;
			case 7: $flash = "Flash, lumire stroboscopique de retour dtecte"; break;
			case 9: $flash = "Flash Obligatoire"; break;
			case 13: $flash = "Flash Obligatoire, Lumire de retour non dtecte"; break;
			case 15: $flash = "Flash Obligatoire, lumire de retour dtecte"; break;
			case 16: $flash = "Aucun"; break;
			case 24: $flash = "Aucun"; break;
			case 25: $flash = "Flash, Mode-Auto"; break;
			case 29: $flash = "Flash, mode-Auto, Lumire de retour non dtecte"; break;
			case 31: $flash = "Flash, Mode-Auto, Lumire de retour dtecte"; break;
			case 32: $flash = "Aucun"; break;
			case 65: $flash = "Yeux Rouges"; break;
			case 69: $flash = "Yeux rouges, Lumire de retour non dtecte"; break;
			case 71: $flash = "Yeux rouges, Lumire de retour dtecte"; break;
			case 73: $flash = "Yeux rouges, Flash Obligatoire"; break;
			case 77: $flash = "Yeux rouges, Flash Obligatoire, Lumire de retour non dtecte"; break;
			case 79: $flash = "Yeux rouges, Flash Obligatoire, Lumire de retour dtecte"; break;
			case 89: $flash = "Yeux rouges, Mode-Auto"; break;
			case 93: $flash = "Yeux rouges, Mode-Auto, Lumire de retour non dtecte"; break;
			case 95: $flash = "Yeux rouges, Mode-Auto, Lumire de retour dtecte"; break;
			default : $flash = "non dtermin"; break;
			}
			?>
		<span class="info_bold"><?php echo $l_flash;?>: </span><span class="info"><?php echo $flash?><br /></span><?php } ?>
		
		<?php if(!empty($details['Make']) && !empty($details['Model'])) { ?><span class="info_bold"><?php echo $l_camera;?>: </span><span class="info"><?php echo $details['Make']." ".$details['Model']; ?> <br /></span><?php } ?>
		<?php if(!empty($details['UserComment'])) { ?><span class="info_bold"><?php echo $l_comments;?>: </span><span class="info"><?php echo $details['UserComment']; ?> <br /></span><?php } ?>
		
		<?php
	}

		//tries to grab keywords and rating for photo
		$info_rating = 0;
		$info_keywords = '';
		if(file_exists("./_cache/".$web_path.$slash."/_photoinfo/".$HTTP_GET_VARS['file'].".txt")) {
			$handle = @fopen("./_cache/".$web_path.$slash."/_photoinfo/".$HTTP_GET_VARS['file'].".txt", "rb");
			$info_rating = @fgets($handle,1024);
			$info_keywords = @fgets($handle,1024);
			$info_rating = str_replace("\n","",$info_rating);
			$info_keywords = str_replace("\n","",$info_keywords);
			@fclose($handle);
		}
		
	?>
	
	<?php 

		if(file_exists("./_cache/_icons/star.gif")) {
			$star_icon = "<img src='./_cache/_icons/star.gif' width='11' height='8' border='0' alt='*' />";
		} else {
			$star_icon = "*";
		}
				
		if(!empty($info_rating) && $display_rating) {
			echo "<span class='info_bold'>".$l_rating.": </span><span class='info'>";
			for($i=0;$i<$info_rating;$i++) echo $star_icon;
			echo "<br /></span>";
		}
	?> 
	<?php 
		if(!empty($info_keywords)) {
			echo "<span class='info_bold'>".$l_comments.": </span><span class='info'>".$info_keywords."<br /></span>";
		}
	?> 
	<hr />
	<span class="info">
	<?php 
		if(file_exists("./_cache/_icons/download.gif")) {
			$download = "<img src='./_cache/_icons/download.gif' width='9' height='10' border='0' alt='*' /> ".$l_download;
		} else {
			$download = $l_download;
		}
		
	?>
	<a href="<?php if(empty($web_path)) echo "."; echo myURLencode($web_path)."/".rawurlencode($HTTP_GET_VARS['file'])?>"><?php echo $download?></a>
	(<?php echo round(filesize($file_path."/".$HTTP_GET_VARS['file'])/1024,0)?> k)
	</span>
	
	</td><td valign="top" class="details_table_cell_r">

	<?php if(!empty($_GET['auto']) && !empty($next)) { ?>
	<script language="JavaScript" type="text/javascript">
	<!--
	function advance() {
		window.location="index.php?op=5&path=<?php echo rawurlencode($web_path)?>&file=<?php echo rawurlencode($next)?>&auto=1";
	}
	
	setTimeout(advance,5000); //5 seconds
	
	//-->
	</script>
	<?php } ?>
	
	<table width="<?php echo $screen_size ?>" border="0" cellpadding="0" cellspacing="0"><tr>
	<td align="left" class="crumbs" width="100"><?php if(!empty($prev)) { ?><a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($prev)?>"><?php echo $prev_icon?> <?php if($show_filename==1) echo truncate($prev,$max_file_length); else echo $l_prev;?></a><?php } ?></td>
	<td align="center" class="crumbs"><?php if(empty($_GET['auto']) && !empty($next)) { ?><a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($next)?>&amp;auto=1"><?php echo $l_slide_start;?></a><?php } else if(!empty($next)) {?><a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($HTTP_GET_VARS['file'])?>"><?php echo $l_slide_stop;?></a><?php } ?></td>
	<td align="right" class="crumbs" width="100"><?php if(!empty($next)) { ?><a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($next)?>"><?php if($show_filename==1)  echo truncate($next,$max_file_length); else echo $l_next;?> <?php echo $next_icon?></a><?php } ?></td>
	</tr></table>
	
	<img src="<?php echo $screen_path?>" border="0" <?php echo $dim; ?> alt="" />
	</td></tr></table>
	<br />
	<?php
	//if admin is turned on, display login box
	if($admin==1 && empty($_COOKIE['admin'])) {
		?>
		<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
		<tr><td class="admin_cell">
		<form action="index.php" method="post">
		<input type="hidden" name="op" value="5" />
		<input type="hidden" name="path" value="<?php if(!empty($HTTP_GET_VARS['path'])) echo $HTTP_GET_VARS['path']?>" />
		<input type="hidden" name="file" value="<?php if(!empty($HTTP_GET_VARS['file'])) echo $HTTP_GET_VARS['file']?>" />
		<span class='info'><?php echo $l_pass;?>: </span><input type="password" name="admin" size="10" class='form_text' />
		<input type="submit" value="<?php echo $l_login;?>" class='form_btn' />
		</form>
		</td></tr></table>
		<?php
	} else if($admin==1 && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		if(file_exists("./_cache/_icons/trash.gif")) {
			$trash = "<img src='./_cache/_icons/trash.gif' width='9' height='10' border='0' alt='del' />";
		} else {
			$trash = "";
		}
		?>
		<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
		<tr><td class="admin_heading" colspan="3">
		<b><?php echo $l_tools;?></b><span class='info'>&nbsp;&nbsp;&nbsp; <a href="index.php?admin=logout&amp;op=5<?php if(!empty($HTTP_GET_VARS['path'])) echo "&amp;path=".rawurlencode($HTTP_GET_VARS['path'])?><?php if(!empty($HTTP_GET_VARS['file'])) echo "&amp;file=".rawurlencode($HTTP_GET_VARS['file'])?>"><?php echo $l_logout;?></a></span>
		</td></tr>
		<tr><td class="admin_cell" rowspan="3" valign="top" width="150"><span class="info">
			<a onclick="return confirm('<?php echo $l_confirm_del;?>');" href="index.php?del=1&amp;path=<?php echo rawurlencode($web_path);?>&amp;file=<?php echo rawurlencode($HTTP_GET_VARS['file'])?>"><?php echo $l_del_photo;?> <?php echo $trash;?></a><br /><br />
			<a href="index.php?regen=1&amp;path=<?php echo rawurlencode($web_path);?>&amp;file=<?php echo rawurlencode($HTTP_GET_VARS['file'])?>"><?php echo $l_regen;?></a>
		</span></td><td class="admin_cell" valign="top" align="right" width="100"><span class='info'><?php echo $l_rename;?>: </span></td><td class="admin_cell">
			<form action="index.php" method="get">
			<input type="hidden" name="renamewhat" value="1" />
			<input type="hidden" name="path" value="<?php echo htmlspecialchars($web_path)?>" />
			<input type="hidden" name="file" value="<?php echo htmlspecialchars($HTTP_GET_VARS['file'])?>" />
			<input type="hidden" name="movepath" value="<?php echo htmlspecialchars($web_path)?>" />
			<input type="text" name="rename" size="32" class='form_text' value="<?php echo htmlspecialchars($HTTP_GET_VARS['file'])?>" />
			
		</td></tr><tr><td class="admin_cell" valign="top" align="right"><span class='info'><?php echo $l_comments;?>: </span></td><td class="admin_cell">
		
			<textarea name="keywords" cols="40" rows="4" class='form_text'><?php echo htmlspecialchars($info_keywords); ?></textarea>
			
		</td></tr><tr><td class="admin_cell" valign="top" align="right"><span class='info'><?php echo $l_rating;?>: </span></td><td class="admin_cell">
			
			<select name="rating" class="form_text">
			<option value="0" <?php if(empty($info_rating)) echo "selected='selected'"; ?>><?php echo $l_norateing;?></option>
			<option value="1" <?php if($info_rating==1) echo "selected='selected'"; ?>>*</option>
			<option value="2" <?php if($info_rating==2) echo "selected='selected'"; ?>>**</option>
			<option value="3" <?php if($info_rating==3) echo "selected='selected'"; ?>>***</option>
			<option value="4" <?php if($info_rating==4) echo "selected='selected'"; ?>>****</option>
			<option value="5" <?php if($info_rating==5) echo "selected='selected'"; ?>>*****</option>
			</select>
			<br /><br />
			<input type="submit" value="<?php echo $l_save;?>" class='form_btn' />
			</form>
			
		</td></tr></table>
		<?php
	}
	?>
	<br /><br />
	<!-- Please leave this tag here so other people can find Fotopholder.  Thanks. -->
	<div class="tag"><?php echo $l_generated;?> <a href="http://www.jakeo.com/software/fotopholder/index.php" class="tag_lnk">Fotopholder <?php echo $version?></a></div>
	</body></html>
	<?php
	exit();
}
?>


<?php
	// START DIRECTORY DISPLAY
	if(empty($web_path)) $slash="";
	else $slash = "/";
	$print_errors=0;
	
	if($admin==0 || $admin_only==0 || (!empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password))) {
		$dirs = getDirList($file_path);
	} else {
		$dirs = -3;
	}
	if($dirs==-1) {
		if($display_errors==1) echo "<div class='error'>".$l_bad_dir.": ".$file_path."</div>";
	}
	if($dirs==-2) {
		if($display_errors==1) echo "<div class='error'>".$l_bad_dir2.": ".$file_path."</div>";
		$print_errors=1;
	}
	if($dirs==-3) {
		echo "<div class='error'>".$l_private."</div>";
	}
	//tries to make the cache sub directory if its not there already
	if(is_dir($file_path) && !file_exists("./_cache/".$web_path)) {
		if($display_errors == 1) echo "<div class='error'>".$l_make_dir.": ./_cache/".$web_path."</div>";
		umask(0);
		$success = @mkdir("./_cache/".$web_path,0777);
		if(!$success) $print_errors = 1;
	}
	
	//tries to make the thumbnail sub directory if its not there already
	if(is_dir($file_path) && !file_exists("./_cache/".$web_path.$slash."_thumbnails")) {
		if($display_errors == 1) echo "<div class='error'>".$l_make_dir.": ./_cache/".$web_path.$slash."_thumbnails</div>";
		umask(0);
		$success = @mkdir("./_cache/".$web_path.$slash."_thumbnails",0777);
		if(!$success) $print_errors = 1;
	}
	
 	//tries to make the screen sub directory if its not there already
	if(is_dir($file_path) && !file_exists("./_cache/".$web_path.$slash."_screen"))  {
		if($display_errors == 1) echo "<div class='error'>".$l_make_dir.": ./_cache/".$web_path.$slash."_screen</div>";
		umask(0);
		$success = @mkdir("./_cache/".$web_path.$slash."_screen",0777);
		if(!$success) $print_errors = 1;
	}
	
	//tries to make the photoinfo sub directory if its not there already
	if(is_dir($file_path) && !file_exists("./_cache/".$web_path.$slash."_photoinfo"))  {
		if($display_errors == 1) echo "<div class='error'>".$l_make_dir.": ./_cache/".$web_path.$slash."_photoinfo</div>";
		umask(0);
		$success = @mkdir("./_cache/".$web_path.$slash."_photoinfo",0777);
		if(!$success) $print_errors = 1;
	}
	
	//tries to make the icon sub directory if its not there already
	if(!file_exists("./_cache/_icons"))  {
		if($display_errors == 1) echo "<div class='error'>".$l_make_dir.": ./_cache/_icons</div>";
		umask(0);
		$success = @mkdir("./_cache/_icons",0777);
		if(!$success) $print_errors = 1;
	}
	
	function download_icon($icon) {
		$handle = @fopen("http://jakeo.com/software/fotopholder/icons/".$icon, "rb");
		$downloaded_icon = @fread($handle, 10000);
		@fclose($handle);

		if(!empty($downloaded_icon)) {
			$handle = @fopen("./_cache/_icons/".$icon, "wb");
			@fwrite($handle,$downloaded_icon);
			@fclose($handle);
		}
	}
	//download icons if  not there
	if(!file_exists("./_cache/_icons/folder.gif")) download_icon("folder.gif");
	if(!file_exists("./_cache/_icons/trash.gif")) download_icon("trash.gif");
	if(!file_exists("./_cache/_icons/download.gif")) download_icon("download.gif");
	if(!file_exists("./_cache/_icons/prev.gif")) download_icon("prev.gif");
	if(!file_exists("./_cache/_icons/next.gif")) download_icon("next.gif");
	if(!file_exists("./_cache/_icons/star.gif")) download_icon("star.gif");
	
	if($print_errors==1 && $display_errors == 1) { //prints errors of it could make the above folders
		echo "<div class='error'>";
		echo $l_make_err;
		echo "</div>";
	}
	
	if(is_array($dirs) && sizeof($dirs)>0) {
		?><table border="0" cellpadding="0" cellspacing="0" class="dir_table"><?php
	}
	
	$dir_sub_cnt = 0;
	$dir_pho_cnt = 0;
	while (is_array($dirs) && false !== ($entry = current($dirs))) {
		$subdir = getDirList($file_path."/".$entry);
		$photos = getPhotoList("./".$web_path.$slash.$entry);
	
		if(count($subdir)==0 && count($photos)==0) {
			//safe to delete this folder because it is totally empty
			if($admin==1 && $delete_empty_folders==1 && $_COOKIE['admin']==md5($password)) {
				$worked = rmdirR($file_path."/".$entry);
				if($worked==FALSE) echo " (".$l_perm_err.")";
			}
			next($dirs);
			continue;
		}
		if(!file_exists("./_cache/".$web_path.$slash.$entry)) { //tries to make the cache sub directory if its not there already
			umask(0);
			$success = @mkdir("./_cache/".$web_path.$slash.$entry,0777);
		}
		
		if(!file_exists("./_cache/".$web_path.$slash.$entry."/_thumbnails")) { //tries to make the thumbnail sub directory if its not there already
			umask(0);
			$success = @mkdir("./_cache/".$web_path.$slash.$entry."/_thumbnails",0777);
		}
		
		//try to cache the number of photos and folders per subdirectory (if it doesnt already exist)
		if(!file_exists("./_cache/".$web_path.$slash.$entry."/info.txt")) {
			$handle = @fopen("./_cache/".$web_path.$slash.$entry."/info.txt", "wb");
			@fwrite($handle,count($photos)."\n");
			@fwrite($handle,count($subdir)."\n");
			@fclose($handle);
		}
		
		?>
		<tr><td class="dir_table_info">
			<table border="0" width="100%" cellpadding="0" cellspacing="0"><tr><td width="15" valign="top">
			<?php if(file_exists("./_cache/_icons/folder.gif")) { ?>
				<a href="index.php?path=<?php echo rawurlencode($web_path.$slash.$entry)?>"><img src="_cache/_icons/folder.gif" width="15" height="14" border="0" align="left" alt="" /></a>
			<?php } else { ?>
				<a href="index.php?path=<?php echo rawurlencode($web_path.$slash.$entry)?>"><img src="index.php?op=4" width="15" height="14" border="0" align="left" alt="" /></a>
			<?php } ?>
			</td><td>
			<span class='folder'><a href="index.php?path=<?php echo rawurlencode($web_path.$slash.$entry)?>"><?php echo $entry?></a></span><br />
			<?php
				//tries to grab cached information about the directory
				if(file_exists("./_cache/".$web_path.$slash.$entry."/info.txt")) {
					$handle = @fopen("./_cache/".$web_path.$slash.$entry."/info.txt", "rb");
					$num_photos = @fgets($handle,1024);
					$num_dirs = @fgets($handle,1024);
					$dir_sub_cnt += $num_dirs;
					$dir_pho_cnt += $num_photos;
					@fclose($handle);
					echo "<span class='info'>".$num_photos." ".$l_photos."<br />".$num_dirs." ".$l_subfold."</span>";
				}
			?>
			</td></tr></table>
		</td>
		<td class="dir_table_thumbs">
		<?php
		if(file_exists("./".$web_path.$slash.$entry) && $num_tinys>0) {
			$count=0;
			while (is_array($photos) && false !== ($thumb = current($photos)) && $count<$num_tinys) { //cycle through photos in subdir to make tinys
				//delete too-small images
				if($admin==1 && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password) && $delete_tiny_files==1 && round(filesize($file_path."/".$entry."/".$thumb)/1024,0)<$tiny_file_max_kbytes) {
					@unlink($file_path."/".$entry."/".$thumb);
					next($photos);
					continue;
				}
		
				$count++;
				if(file_exists("./_cache/".$web_path.$slash.$entry."/_thumbnails/".$thumb))  { ?>
				<a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path.$slash.$entry)?>&amp;file=<?php echo rawurlencode($thumb)?>"><img src="_cache/<?php echo myURLencode($web_path.$slash.$entry)?>/_thumbnails/<?php echo rawurlencode($thumb)?>" width="<?php echo $tiny_size?>" height="<?php echo $tiny_size?>" title="<?php echo $l_enlarge;?>" align="middle" alt="" /></a>
				<?php } else { ?>
				<a href="index.php?op=5&amp;path=<?php echo rawurlencode($web_path.$slash.$entry)?>&amp;file=<?php echo rawurlencode($thumb)?>"><img src="index.php?op=1&amp;path=<?php echo rawurlencode($web_path.$slash.$entry)?>&amp;file=<?php echo rawurlencode($thumb)?>" width="<?php echo $tiny_size?>" height="<?php echo $tiny_size?>" title="<?php echo $l_enlarge;?>" align="middle" alt="" /></a>
				<?php 
				} 
				next($photos);
			}
		}
		next($dirs);
		if($count==$num_tinys) {
			echo "&nbsp;<a href='index.php?path=".rawurlencode($web_path.$slash.$entry)."'>".$l_more."</a></td></tr>";
		} else if($count==0) {
			if(count($subdir)==0) {
				echo "Empty";
				if($admin==1 && $delete_empty_folders==1 && $_COOKIE['admin']==md5($password)) {
					$worked = rmdirR($file_path."/".$entry);
					if($worked==FALSE) echo " (".$l_perm_err.")";
				}
			} else { 
				$count = 0;
				foreach($subdir as $sd) {
					$count++;
					if($count>$num_tinys) {
						echo "<a href='index.php?path=".rawurlencode($web_path.$slash.$entry)."'>".$l_more."</a>";
						break;
					}
					if(file_exists("./_cache/_icons/folder.gif")) { 
						?><a href="index.php?path=<?php echo rawurlencode($web_path.$slash.$entry."/".$sd)?>"><img src="_cache/_icons/folder.gif" width="15" height="14" border="0" align="left" alt="" /></a><?php 
					} else { 
						?><a href="index.php?path=<?php echo rawurlencode($web_path.$slash.$entry."/".$sd)?>"><img src="index.php?op=4" width="15" height="14" border="0" align="left" alt="" /></a><?php 
					}
				}
			}
			echo "</td></tr>";
		} else {
			echo "</td></tr>";
		}
	}
	
	if(is_array($dirs) && sizeof($dirs)>0) echo "</table>";
	
	// END DIRECTORY DISPLAY
?>


<br />

<?php
	// START PHOTO DISPLAY
	if($admin==0 || $admin_only==0 || (!empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password))) {
		$photos = getPhotoList($file_path);
	} else {
		$photos = null;
	}
	$col = 0;
	$images=0;
	$max_images = sizeof($photos);
	if($max_images < $thumbs_page) $thumbs_page = $max_images;
	
	
	if(!empty($_GET['page'])) {
		$skip = ($_GET['page']-1)*$thumbs_page;
		for($skip;$skip>0;$skip--) next($photos);
	} else {
		$_GET['page'] = 1;
	}
	
	//next and previous links
	if($max_images>$thumbs_page || $_GET['page']>1) {
		$last_page = ceil($max_images/$thumbs_page);
		?><table border="0" cellpadding="0" cellspacing="0" class="photo_table"><tr><?php
		
		if($_GET['page']>1) {
			echo "<td class='photo_table_cell_n' width='100'><a href='index.php?path=".rawurlencode($web_path)."&amp;page=".($_GET['page']-1)."'>".$l_prev_pg."</a></td>";
		}
		
		echo "<td class='photo_table_cell_n' align='center'>";
		for($i=1;$i<=$last_page;$i++) {
		 if($i==$_GET['page']) echo "<b>".$i."</b>&nbsp;&nbsp;";
		 else echo "<a href='index.php?path=".rawurlencode($web_path)."&amp;page=".$i."'>".$i."</a>&nbsp;&nbsp;";
		}
		echo "</td>";
		
		if($max_images>$_GET['page']*$thumbs_page) {
			echo "<td class='photo_table_cell_n' align='right' width='100'><a href='index.php?path=".rawurlencode($web_path)."&amp;page=".($_GET['page']+1)."'>".$l_next_pg."</a></td>";
		}
		?></tr></table><br /><?php
	}
	
	if(is_array($photos) && sizeof($photos)>0) {
		?><table border="0" cellpadding="0" cellspacing="0" class="photo_table"><?php
	}
	
	while ($images<$thumbs_page && is_array($photos) && false !== ($entry = current($photos))) {
		
		//delete too-small images
		if($admin==1 && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password) && $delete_tiny_files==1 && round(filesize($file_path."/".$entry)/1024,0)<$tiny_file_max_kbytes) {
			@unlink($file_path."/".$entry);
			next($photos);
			continue;
		}
		
		//delete cache if original has changed
		$cacheTime = @filemtime("./_cache/".$web_path.$slash."_thumbnails/".$entry);
		$srcTime = @filemtime($web_path.$slash.$entry);
		$now = time();
		if($cacheTime && $srcTime && $cacheTime<$now && $srcTime<$now && $cacheTime<$srcTime) {
			@unlink("./_cache/".$web_path.$slash."_thumbnails/".$entry);
			@unlink("./_cache/".$web_path.$slash."_screen/".$entry);
		}
		
		if($col==0) echo "<tr>";
		$col++;
		$images++;
		?>
			<td align="center" valign="top" class="photo_table_cell<?php if($col==1) echo"_l"; else if($col==$thumb_cols) echo "_r"; ?>" width="<?php echo $thumb_size?>">
				<?php 
					if(empty($web_path)) $download_path = ".".myURLencode($web_path)."/".rawurlencode($entry);
					else $download_path=myURLencode($web_path)."/".rawurlencode($entry);
					$link_path = "index.php?op=5&amp;path=".rawurlencode($web_path)."&amp;file=".rawurlencode($entry);
						
					if(file_exists("./_cache/".$web_path.$slash."_thumbnails/".$entry))  {
				?>
					<a href="<?php echo $link_path; ?>"><img src="_cache/<?php echo myURLencode($web_path)?>/_thumbnails/<?php echo rawurlencode($entry)?>" width="<?php echo $thumb_size?>" height="<?php echo $thumb_size?>" title="<?php echo $l_enlarge;?>" class="photo_thumb" alt="" /></a><br />
				<?php } else { ?>
					<a href="<?php echo $link_path; ?>"><img src="index.php?op=1&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($entry)?>" width="<?php echo $thumb_size?>" height="<?php echo $thumb_size?>" title="<?php echo $l_enlarge;?>" class="photo_thumb" alt="" /></a><br />
				<?php } ?>
				<span class='info'>
				<?php if($show_filename==1) echo truncate($entry,$max_file_length)."<br />"; ?>				
				<?php 
					if($display_rating) {
						if(file_exists("./_cache/_icons/star.gif")) {
							$star_icon = "<img src='./_cache/_icons/star.gif' width='11' height='8' border='0' alt='*' />";
						} else {
							$star_icon = "*";
						}
						if(file_exists("./_cache/".$web_path.$slash."/_photoinfo/".$entry.".txt")) {
							$handle = @fopen("./_cache/".$web_path.$slash."/_photoinfo/".$entry.".txt", "rb");
							$info_rating = @fgets($handle,1024);
							for($i=0;$i<$info_rating;$i++) echo $star_icon;
							if($info_rating>0) echo "<br />";
							@fclose($handle);
						}
					}
				?>
				
				<a href="<?php echo $download_path; ?>"><?php echo $l_download2;?></a>
				(<?php echo round(filesize($file_path."/".$entry)/1024,0)?> k)
				<?php 
					if(file_exists("./_cache/_icons/trash.gif")) {
						$trash = "<img src='./_cache/_icons/trash.gif' width='9' height='10' border='0' alt='del' />";
					} else {
						$trash = "del";
					}
				?>
				<?php if($admin==1 && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) { ?><a onclick="return confirm('<?php echo $l_confirm_del;?>');" href="index.php?del=1&amp;path=<?php echo rawurlencode($web_path)?>&amp;file=<?php echo rawurlencode($entry)?>&amp;page=<?php echo $_GET['page']?>"><?php echo $trash;?></a><?php } ?>
				</span> 
			</td>
		<?php
		next($photos);
		
		if($col==$thumb_cols && current($photos)) {
			echo "</tr><tr><td class='photo_table_spacer' colspan='".$thumb_cols."'></td></tr>";
			$col=0;
		}
	}

	if($col>0) {
		for($col;$col<$thumb_cols;$col++) echo "<td class='photo_table_cell_e' width='".$thumb_size."'>&nbsp;</td>";
		echo "</tr>";
	}

	//empty folder
	if(count($photos)==0 && count($dirs)==0) {
		echo "<tr><td colspan='".$thumb_cols."'><span class='folder'><br />".$l_fol_empty."<br /><br /></span></td></tr>";
	}
	
	//try to cache the number of photos and folders per directory
	$handle = @fopen("./_cache/".$web_path.$slash."info.txt", "wb");
	@fwrite($handle,(count($photos)+$dir_pho_cnt)."\n");
	@fwrite($handle,(count($dirs)+$dir_sub_cnt)."\n");
	@fclose($handle);
	
	if($images>0) echo "</table>";
	
	//next and previous links
	if($max_images>$thumbs_page || $_GET['page']>1) {
		$last_page = ceil($max_images/$thumbs_page);
		?><br /><table border="0" cellpadding="0" cellspacing="0" class="photo_table"><tr><?php
		
		if($_GET['page']>1) {
			echo "<td class='photo_table_cell_n' width='100'><a href='index.php?path=".rawurlencode($web_path)."&amp;page=".($_GET['page']-1)."'>".$l_prev_pg."</a></td>";
		}
		
		echo "<td class='photo_table_cell_n' align='center'>";
		for($i=1;$i<=$last_page;$i++) {
		 if($i==$_GET['page']) echo "<b>".$i."</b>&nbsp;&nbsp;";
		 else echo "<a href='index.php?path=".rawurlencode($web_path)."&amp;page=".$i."'>".$i."</a>&nbsp;&nbsp;";
		}
		echo "</td>";
		
		if($max_images>$_GET['page']*$thumbs_page) {
			echo "<td class='photo_table_cell_n' align='right' width='100'><a href='index.php?path=".rawurlencode($web_path)."&amp;page=".($_GET['page']+1)."'>".$l_next_pg."</a></td>";
		}
		?></tr></table><?php
	}
	
	// END PHOTO DISPLAY
	
?>

<br />
<?php
	if(empty($web_path) && file_exists("./_cache/friend.txt")) {
	?>
	
	<table border="0" cellpadding="0" cellspacing="0" class="friend_table">
		<tr><td class="friend_heading"><?php echo $l_friend;?></td></tr>
		<tr><td class="friend_cell">
		<?php
		$handle = fopen("./_cache/friend.txt", "rb");
		$url = @fgets($handle,1024);
		$title = @fgets($handle,1024);
		while($url) {
			?>
			<a href="<?php echo $url?>"><?php echo $title?></a><br />
			<?php
			$url = @fgets($handle,1024);
			$title = @fgets($handle,1024);
		}
		fclose($handle);
		?>
		</td></tr>
	</table>
		
	<?php
	}
?>
<br />

<?php
	//if admin is turned on, display login box
	if($admin==1 && empty($_COOKIE['admin'])) {
		?>
		<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
		<tr><td class="admin_cell">
		<form action="index.php" method="post">
		<input type="hidden" name="path" value="<?php if(!empty($HTTP_GET_VARS['path'])) echo $HTTP_GET_VARS['path']?>" />
		<span class='info'><?php echo $l_pass;?>: </span><input type="password" name="admin" size="10" class='form_text' />
		<input type="submit" value="<?php echo $l_login;?>" class='form_btn' />
		</form>
		</td></tr></table>
		<?php
	} else if($admin==1 && !empty($_COOKIE['admin']) && $_COOKIE['admin']==md5($password)) {
		if(file_exists("./_cache/_icons/trash.gif")) {
			$trash = "<img src='./_cache/_icons/trash.gif' width='9' height='10' border='0' alt='del' />";
		} else {
			$trash = "";
		}
		
		if(!empty($_GET['cache']) && $no_screen==0) {
			?>
			<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
			<tr><td class="admin_heading"><?php echo $l_gen_cache;?></td></tr>
			<tr><td class="admin_cell">
				<?php 
				$photos = getPhotoList($file_path);
				while (is_array($photos) && false !== ($entry = current($photos))) {
					echo "<img src='index.php?op=1&amp;path=".rawurlencode($web_path)."&amp;file=".rawurlencode($entry)."' width='10' height='10' alt='' />";
					echo "<img src='index.php?op=2&amp;path=".rawurlencode($web_path)."&amp;file=".rawurlencode($entry)."' width='10' height='10' alt='' />";
					next($photos);
				}
				?>
			</td></tr>
			</table><br />
		<?php } ?>
		
		<?php
		if(!empty($_GET['archive'])) {
			$command = "tar -czvf ".escapeshellarg("_cache/".$web_path.".tgz")." ".escapeshellarg($web_path);
			exec($command);
			?>
			<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
			<tr><td class="admin_heading"><?php echo $l_gen_zip;?></td></tr>
			<tr><td class="admin_cell"><?php echo $l_complete;?></td></tr>
			</table><br />
		<?php } ?>
		
		<table border="0" cellpadding="0" cellspacing="0" class="admin_table">
		<tr><td class="admin_heading" colspan="2">
		<?php echo $l_tools;?><span class='info'>&nbsp;&nbsp;&nbsp; <a href="index.php?admin=logout<?php if(!empty($HTTP_GET_VARS['path'])) echo "&amp;path=".rawurlencode($HTTP_GET_VARS['path'])?>"><?php echo $l_logout;?></a></span>
		</td></tr>
		<tr><td class="admin_cell"><span class='info'>
		<?php if(!empty($web_path)) {  ?>
			<a onclick="return confirm('<?php echo $l_confirm_del2;?>');" href="index.php?del=1&amp;path=<?php echo rawurlencode($web_path);?>"><?php echo $l_del_folder;?> <?php echo $trash;?></a><br /><br />
		<?php } ?>
		<a href="index.php?cache=1&amp;path=<?php echo rawurlencode($web_path);?>"><?php echo $l_gen_cache2;?></a><br />
		<a href="index.php?archive=1&amp;path=<?php echo rawurlencode($web_path);?>"><?php echo $l_gen_zip2;?></a><br />
		<a href="index.php?flatten=1&amp;path=<?php echo rawurlencode($web_path);?>"><?php echo $l_flatten;?></a><br />
		
		</span></td><td class="admin_cell">
		<?php if(!empty($web_path)) { 
			$array =split("/",$web_path);
			$filename = array_pop($array);
			$rename_path = implode("/",$array);
			$curdir = array_pop($array);
			$aswego="";
			?>
			
			<form action="index.php" method="get">
			<input type="hidden" name="renamewhat" value="2" />
			<input type="hidden" name="path" value="<?php echo htmlspecialchars($rename_path)?>" />
			
			<?php if(!empty($rename_path)) { ?>
			<span class='info'><?php echo $l_move_to;?>: </span>
			<select name="movepath">
			<option value=""><?php echo $l_move_top;?></option>
			<?php foreach($array as $p) { 
				if(!empty($aswego)) $aswego.="/".htmlspecialchars($p); else $aswego=htmlspecialchars($p);
			?>
			<option value="<?php echo $aswego?>"><?php echo htmlspecialchars($p)?></option>
			<?php } ?>
			<option value="<?php echo $aswego."/".htmlspecialchars($curdir)?>" selected="selected"><?php echo $l_no_move;?></option>
			</select>
			<?php } else { ?>
			<input type="hidden" name="movepath" value="<?php echo htmlspecialchars($rename_path)?>" />
			<?php } ?>
			
			<input type="hidden" name="file" value="<?php echo htmlspecialchars($filename)?>" />
			<span class='info'><?php echo $l_rename_fold;?>: </span><input type="text" name="rename" size="32" class="form_text" value="<?php echo htmlspecialchars($filename);?>" />
			<input type="submit" value="Rename &amp; Move" class='form_btn' />
			</form>
		<?php } else { ?>
			<span class="info_bold"><?php echo $l_add_friend;?></span><br /><br />
			
			<form action="index.php" method="get">
			<span class='info'><?php echo $l_url;?>: </span>
			<input type="text" name="friend" size="32" class='form_text' value="http://" />
			<input type="submit" value="<?php echo $l_add_friend2;?>" class='form_btn' />
			</form>
		<?php } ?>
		
			</td></tr></table>
	<?php 
	}
?>
<?php if(file_exists("_cache/".$web_path.".tgz")) echo "<br /><div class='tag'><a href='_cache/".$web_path.".tgz'>".$l_download_zip."</a></div>"; ?>

<br /><br />
<!-- Please leave this tag here so other people can find Fotopholder.  Thanks. -->
<div class="tag"><?php echo $l_generated;?> <a href="http://www.jakeo.com/software/fotopholder/index.php" class="tag_lnk">Fotopholder <?php echo $version?></a>

<?php
//This checkes the version number to see if there are any updates that you can install.  
//It also sends the number of photos that you are using this script to manage.  The sole purpose
//of this is so that we can display the total number of users and photos on the fotopholder website.
//This information cannot be linked back to you and no personally identifable information is sent from your computer.
//If you choose to enable the gallery link setting this will send the URL of your site so we can link to you on the FotoPholder website.
$non_personal_identifier = md5($_SERVER["SERVER_NAME"].$_SERVER["PHP_SELF"]);
if($gallery_link==1 && !empty($gallery_link_url)) $extra = "&site=".$gallery_link_url;

if(file_exists("./_cache/info.txt")) {
	$handle = @fopen("./_cache/info.txt", "rb");
	$total_photos = trim(@fgets($handle,1024));
	@fclose($handle);
}	
$handle = @fopen("http://www.jakeo.com/software/fotopholder/icons/version.php?id=".$non_personal_identifier."&photos=".$total_photos.$extra, "rb");
$current_version = trim(@fgets($handle,10));

if($version!=$current_version) {
	$whats_new = @fgets($handle,1024);
	echo "<br />".$whats_new;
}
@fclose($handle);
?>
</div>
<br />
</body></html>
<?php } ?>
